# Assignment 1

## Research existing solutions (by Samat Gatin)

### Foundation

Briefly explained concept info: [Chatbots: A Hands-On Guide With Langchain](https://viso.ai/deep-learning/chatbots-guide-with-langchain/) 

We actually focusing on LangChain technology, not on design  
We build an instrument for Sales Manager with common chat-bot interface: ([very-very simple design example](https://www.figma.com/design/kLdABU0vNrFWeg7Nc4ro3g/Untitled?node-id=101-2&node-type=frame&t=SkHFjh1wiU2tHH2o-0))

### Similar products based on this concept:

1. E-commerce AI Assistant (this is the exact use case of LLM technology that our customer wants)  
link: (https://github.com/patterns-ai-core/ecommerce-ai-assistant-demo)
video of the demo: (https://www.loom.com/share/83aa4fd8dccb492aad4ca95da40ed0b2)


2. Trading automation resource  
link: [Автоматизация процессов | ЭТП «Торги223»](https://torgi223.ru/services/avtomatizacziya-proczessov/)


3. Deployment of LangChain Apps for chatbots, search, etc.  
link: [Deploy LangChain Apps on Railway](https://railway.app/template/oE8sWo)


4. E-commerce Chatbot With Redis  
link: [Build an E-commerce Chatbot With Redis, LangChain, and OpenAI](https://redis.io/blog/build-ecommerce-chatbot-with-redis/)

## Prepare a script for the initial interview with the customer (by Kotomceva Aniia)
### Our script looked like a spreadsheet of questions that we sent out the day before the meeting so that the client could review it and carefully consider the idea:
| Group of Questions                | Questions                                                                                                                                                       |
|-----------------------------------|----------------------------------------------------------------------------------------------------------------------------------------------------------------|
| Stakeholders                      | Can you name the key stakeholders on your side who will be involved in the design and make key decisions?                                                        |
|                                   | What roles, functions and responsibilities will each of these stakeholders have?                                                                                |
|                                   | Are any other contractors in related areas related to this project present on the project?                                                                      |
|                                   | Who will be the primary users of the system?                                                                                                                   |
|                                   | Are there different categories of users with different requirements?                                                                                           |
|                                   | Is there a plan to monitor the performance of the work? For example, through regular meetings, use of project management systems?                               |
|                                   | What is your preferred communication format?                                                                                                                   |
| Analogues                         | Can you tell me about the products you like or dislike? What do you dislike or like about them?                                                                |
|                                   | Is there a preference for design and structure? (screenshots)                                                                                                  |
| Business goals                    | What challenges do you face with your current solutions?                                                                                                        |
|                                   | What specific goals do you have for the new Chatbot?                                                                                                           |
|                                   | What exactly should the new application contribute to?                                                                                                         |
| Business process                  | What does the process look like without the Chatbot? AS IS                                                                                                      |
| Functional and System Requirements| What should be the logic for generating commercial offers in Chatbot? TO BE                                                                                     |
|                                   | Should the Chatbot engage in dialogue, answer questions, or just accept commands?                                                                               |
|                                   | The format of the input data?                                                                                                                                  |
|                                   | What inputs are needed to create a sales CO (Commercial offer)?                                                                                                |
|                                   | Which operation in ChatBot results in the creation of a Commercial Offer? Can you give examples?                                                               |
|                                   | Is it required to search for a product by category? (YES/NO)                                                                                                   |
|                                   | What should be included in each commercial offer? Is there a CO template? Can you provide samples or style preferences? What is the file format?               |
|                                   | How should a Chatbot respond to different requests or situations?                                                                                              |
|                                   | How should the Chatbot respond to insufficient information from the user?                                                                                      |
|                                   | Should Chatbot be able to offer alternative solutions or suggestions?                                                                                          |
|                                   | How will the information be kept up to date?                                                                                                                  |
|                                   | Will there be an option for users to edit the offer or save it for future use?                                                                                 |
|                                   | Do prices in different currencies need to be taken into account? (YES/NO)                                                                                     |
|                                   | Is it necessary to store offers in a database and have a dashboard to view offers, their current status (paid/rejected/postponed) and analytics?               |
|                                   | What are the key features that should be in the first version of the product (MVP)?                                                                            |
| Integration with other systems    | Do you need integration with existing systems?                                                                                                                 |
|                                   | What data formats or APIs are used by existing systems for integration?                                                                                        |
| Technical unit                    | Should any specific technologies be used for a Chatbot?                                                                                                        |
|                                   | How fast should a Chatbot respond to queries? Response time?                                                                                                   |
|                                   | How should ChatGPT be used?                                                                                                                                    |
|                                   | What is the structure of the product database and how will it be accessed?                                                                                     |
|                                   | How does API satu work and how will we access it?                                                                                                              |
|                                   | Probable problems accessing satu and asb - documentation for API without VPN doesn't work at all. What solution did you find for yourself?                     |
|                                   | Are specific chatbot settings required via telegram settings: inability to forward messages, take a screenshot?                                                |
| Data security                     | What are the data security requirements?                                                                                                                      |
| Further development               | Are there scalability requirements (ability to increase load)?                                                                                                |
|                                   | Do you have an idea of how current requirements may change in the future and how that will affect the architecture?                                             |
|                                   | What are the bot's support and maintenance requirements?                                                                                                       |
| Implementation timeframe          | Are there milestones that need to be completed by certain deadlines? (deadlines other than those given in the course)?                                         |
| Concerns and Risks                | Are there any prior concerns or issues that could derail the project?                                                                                          |
|                                   | What project risks are you most concerned about?                                                                                                              |
### According to the Mum's Test concept, we followed three rules:
1. Talk about the client's business processes and problems, not about your idea:
Shifted the conversation from solution to experience, problems faced by the customer, this avoided biased feedback.
2. Talk less and listen more to the customer: Preferred active listening over reasoning, but guided the customer through the brief, avoiding philosophising.
3.  Instead of common questions, ask specific ones: Avoided asking hypothetical and rhetorical questions about future actions:


"Can you give examples of products that you like or dislike? "

Redesigned and Improved  according to the concept of MOM :

    "Can you tell me about the products you like or dislike? What do you dislike or like about them?"

"What problem do you plan to solve with the Chatbot?"

Redesigned and Improved according to the concept of MOM :

    "What challenges do you face with your current solutions?"

 "CO(Commercial offer) creation trigger?"

Redesigned and Improved according to the concept of MOM :

    "Which operation in ChatBot results in the creation of a Commercial Offer ? Can you give examples?"

### We had a 60-minute meeting with a recording of the meeting, discussing what the process looks like now and what we should get. At the end of the meeting, we sent the customer a list of tasks to complete in a shared chat room that affected further research. The proof of the meeting is in the screenshots:

Screenshot #1 – demonstration of existing agent app with non-structured requests – our project will do the same, but with commercial offers for manager

![alt text](images/image0.png)  

After demonstration of similar application, we moved to solving our questions from our interview plan  

![alt text](images/image1.png)







## Arrive at an initial vision for the MVP (by Kamil Foatov)

Features to be included in the MVP come from the simplest interaction scenario:

1. *The user redirects the client's request to the Telegram bot.*
    - There is a telegram bot processing messages from the user.
    - No authentication or user verification required since the bot is proprietary.
    - The request is written in plain text and sent as a regular message.
    - The bot operates with special commands to start a new chat and clear the conversation context.
2. *The bot processes the request and pulls the data needed to form an offer with the customer.*
    - This is impossible without LLMs, so the bot uses an AI library to process the data.
3. *If the provided data is not enough to make an offer, the bot sends clarifying messages or suggests preferable options.*
    - The AI library used remembers the context and can conduct a conversation, since several clarifying messages may be sent before the final conclusion.
    - Only one conversation context is stored in the bot at a time. It is not possible to process requests from two clients asynchronously.
4. *If the provided data is enough to make an offer, send the offer conditions and agreement in the PDF format.*
    - A library transforming text into PDF is used to form the proper offer. 

## Write a 1-page report on what you’ve learned (by Ravil Nurgaliev)

### Main learned aspects during preparation stages:
#### Team forming
These steps are common in project development, and helped us to set up work process.
#### Research existing solutions
During this stage, we studied the subject area and identified potential tools and areas of development. So this clarified idea of what the customer wants.
#### Interview scripts
Creating and refining list of all questions helped with even better understanding of potential functionality. 
Also, it guaranteed that meeting will be productive and not 10 hours long.

### Questions that we should clarify
**After actual meeting with customer, these questions  appeared:**  
	- Better understanding of actual work process in customers' company - by direct dialogue with employee  
	- AI tool that suits better for our project  
	- Examples and documentation for LangChain framework  

### Next steps
- Arrange additional meeting with customer and actual employee, who will help us with process understanding
- We need to check old project done for customer to potentially base our project on it  
- Process scheme creation  
- Start to inspect AI tool's documentation (when we clarify it soon) which we will use via API  

### Conclusion
These steps helped us create work process quick and collect requirements from customer to start whole development  
Focusing on clear communication and understanding of each need/function of project is significant.