import os

from fastapi import FastAPI
from .routes import pdf_offer, satu_products, aco_products
import uvicorn
import sys

app = FastAPI(title="ACO_API")

app.include_router(satu_products.router)
app.include_router(pdf_offer.router)
app.include_router(aco_products.router)

app_port = os.getenv("PORT")

if len(sys.argv) > 1:
    app_host = sys.argv[1]
else:
    app_host = "127.0.0.1"

print("current host is", app_host)

if __name__ == "__main__":
    uvicorn.run(
        "API.api_main:app", host=app_host, port=int(app_port), reload=True
    )
