import os
from dotenv import load_dotenv
from fastapi import APIRouter
import requests


load_dotenv()
router = APIRouter(prefix="/satu_product", tags=["Product from SATU"])


@router.get("/{sku}")
def get_product_info(sku: str):
    sku = str(sku).replace("'", '"')

    sku_list = [sku]

    url = os.getenv("MARKETPLACE_API_URL")
    header = {"x-api-key": os.getenv("MARKETPLACE_API_KEY")}

    data = {"sku_list": sku_list, "minimalist_mode": "True"}

    product_data = requests.post(url, headers=header, json=data)

    return {"product_data": product_data.json()}
