import pandas as pd


# everything hardcode
def obo_excel_to_json(file_path, json_path):
    df = pd.read_excel(
        file_path, sheet_name="ОБО НАЛ", skiprows=9, usecols="A, B, C, D, F"
    )
    df_cleaned = df.dropna(subset=["Код", "Артикул"])
    df_cleaned.columns = [
        "code",
        "sku",
        "name",
        "description",
        "quantity_in_stock",
    ]
    df_cleaned = df_cleaned.reset_index(drop=True)

    cost = pd.read_excel(file_path, sheet_name="ОБО BET", usecols="A, D, E")
    cost_cleaned = cost.dropna()

    cost_cleaned.columns = ["code", "cost", "measure_unit"]
    cost_cleaned = cost_cleaned.reset_index(drop=True)

    df_left = pd.merge(df_cleaned, cost_cleaned, on="code", how="left")
    df_left = df_left.astype({"sku": "string"})
    df_left.to_json(json_path, orient="records", force_ascii=False, indent=4)


if __name__ == "__main__":
    file_path = "../data/CO_example.xlsm"  # путь к файлу
    json_path = "../data/product_quantity_OBO_data.json"

    obo_excel_to_json(file_path, json_path)
