import os
from dotenv import load_dotenv

import asyncio
import logging
from aiogram import Bot, Dispatcher
from .handlers import router

from aiogram.types import BotCommand

load_dotenv()
bot = Bot(token=os.getenv("TOKEN"))
dp = Dispatcher()


async def set_bot_commands():
    commands = [
        BotCommand(command="/start", description="Запуск бота"),
        BotCommand(command="/help", description="Помощь"),
        BotCommand(command="/settings", description="Текущие настройки"),
        BotCommand(command="/pdf", description="Сгенерировать КП в PDF"),
    ]
    await bot.set_my_commands(commands)


async def main():
    dp.include_router(router)
    await set_bot_commands()
    await dp.start_polling(bot)


if __name__ == "__main__":
    logging.basicConfig(level=logging.INFO)

    try:
        asyncio.run(main())
    except KeyboardInterrupt:
        print("exit")
